Index: trunk/source/processes/electromagnetic/lowenergy/src/G4LivermoreComptonModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4LivermoreComptonModel.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4LivermoreComptonModel.cc	(revision 1055)
@@ -24,7 +24,19 @@
 // ********************************************************************
 //
-// $Id: G4LivermoreComptonModel.cc,v 1.1 2008/10/30 14:17:46 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-02 $
-//
+// $Id: G4LivermoreComptonModel.cc,v 1.6 2009/04/18 18:29:34 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+//
+//
+// Author: Sebastien Inserti
+//         30 October 2008
+//
+// History:
+// --------
+// 18 Apr 2009   V Ivanchenko Cleanup initialisation and generation of secondaries:
+//                  - apply internal high-energy limit only in constructor 
+//                  - do not apply low-energy limit (default is 0)
+//                  - remove GetMeanFreePath method and table
+//                  - added protection against numerical problem in energy sampling 
+//                  - use G4ElementSelector
 
 #include "G4LivermoreComptonModel.hh"
@@ -37,13 +49,14 @@
 
 G4LivermoreComptonModel::G4LivermoreComptonModel(const G4ParticleDefinition*,
-                                             const G4String& nam)
-:G4VEmModel(nam),isInitialised(false)
+						 const G4String& nam)
+  :G4VEmModel(nam),isInitialised(false),meanFreePathTable(0),
+   scatterFunctionData(0),crossSectionHandler(0)
 {
-  lowEnergyLimit = 250 * eV; // SI - Could be 10 eV ?
+  lowEnergyLimit = 250 * eV; 
   highEnergyLimit = 100 * GeV;
-  SetLowEnergyLimit(lowEnergyLimit);
+  //  SetLowEnergyLimit(lowEnergyLimit);
   SetHighEnergyLimit(highEnergyLimit);
 
-  verboseLevel= 0;
+  verboseLevel=0 ;
   // Verbosity scale:
   // 0 = nothing 
@@ -52,11 +65,12 @@
   // 3 = calculation of cross sections, file openings, sampling of atoms
   // 4 = entering in methods
-  
-  G4cout << "Livermore Compton model is constructed " << G4endl
-         << "Energy range: "
-         << lowEnergyLimit / keV << " keV - "
-         << highEnergyLimit / GeV << " GeV"
-         << G4endl;
- 
+
+  if(  verboseLevel>0 ) { 
+    G4cout << "Livermore Compton model is constructed " << G4endl
+	   << "Energy range: "
+	   << lowEnergyLimit / eV << " eV - "
+	   << highEnergyLimit / GeV << " GeV"
+	   << G4endl;
+  }
 }
 
@@ -65,7 +79,6 @@
 G4LivermoreComptonModel::~G4LivermoreComptonModel()
 {  
-  delete meanFreePathTable;
-  delete crossSectionHandler;
-  delete scatterFunctionData;
+  if (crossSectionHandler) delete crossSectionHandler;
+  if (scatterFunctionData) delete scatterFunctionData;
 }
 
@@ -73,27 +86,15 @@
 
 void G4LivermoreComptonModel::Initialise(const G4ParticleDefinition* particle,
-                                       const G4DataVector& cuts)
+					 const G4DataVector& cuts)
 {
   if (verboseLevel > 3)
     G4cout << "Calling G4LivermoreComptonModel::Initialise()" << G4endl;
 
-  InitialiseElementSelectors(particle,cuts);
-
-  // Energy limits
-  
-  if (LowEnergyLimit() < lowEnergyLimit)
-    {
-      G4cout << "G4LivermoreComptonModel: low energy limit increased from " << 
-	LowEnergyLimit()/eV << " eV to " << lowEnergyLimit << " eV" << G4endl;
-      SetLowEnergyLimit(lowEnergyLimit);
-    }
-
-  if (HighEnergyLimit() > highEnergyLimit)
-    {
-      G4cout << "G4LivermoreComptonModel: high energy limit decreased from " << 
-	HighEnergyLimit()/GeV << " GeV to " << highEnergyLimit << " GeV" << G4endl;
-      SetHighEnergyLimit(highEnergyLimit);
-    }
-
+  if (crossSectionHandler)
+  {
+    crossSectionHandler->Clear();
+    delete crossSectionHandler;
+  }
+  
   // Reading of data files - all materials are read
   
@@ -113,25 +114,19 @@
   shellData.LoadData(file);
 
-  meanFreePathTable = 0;
-  meanFreePathTable = crossSectionHandler->BuildMeanFreePathForMaterials();
-  
   if (verboseLevel > 2) 
     G4cout << "Loaded cross section files for Livermore Compton model" << G4endl;
 
-  G4cout << "Livermore Compton model is initialized " << G4endl
-         << "Energy range: "
-         << LowEnergyLimit() / keV << " keV - "
-         << HighEnergyLimit() / GeV << " GeV"
-         << G4endl;
-
-  //
-  
+  InitialiseElementSelectors(particle,cuts);
+
+  if(  verboseLevel>0 ) { 
+    G4cout << "Livermore Compton model is initialized " << G4endl
+	   << "Energy range: "
+	   << LowEnergyLimit() / eV << " eV - "
+	   << HighEnergyLimit() / GeV << " GeV"
+	   << G4endl;
+  }
+  //  
   if(isInitialised) return;
-
-  if(pParticleChange)
-    fParticleChange = reinterpret_cast<G4ParticleChangeForGamma*>(pParticleChange);
-  else
-    fParticleChange = new G4ParticleChangeForGamma();
-    
+  fParticleChange = GetParticleChangeForGamma();
   isInitialised = true;
 }
@@ -148,5 +143,7 @@
     G4cout << "Calling ComputeCrossSectionPerAtom() of G4LivermoreComptonModel" << G4endl;
 
-  G4double cs = crossSectionHandler->FindValue(G4int(Z), GammaEnergy);
+  if (GammaEnergy < lowEnergyLimit || GammaEnergy > highEnergyLimit) return 0.0;
+    
+  G4double cs = crossSectionHandler->FindValue(G4int(Z), GammaEnergy);  
   return cs;
 }
@@ -155,9 +152,9 @@
 
 void G4LivermoreComptonModel::SampleSecondaries(std::vector<G4DynamicParticle*>* fvect,
-					      const G4MaterialCutsCouple* couple,
-					      const G4DynamicParticle* aDynamicGamma,
-					      G4double,
-					      G4double)
+						const G4MaterialCutsCouple* couple,
+						const G4DynamicParticle* aDynamicGamma,
+						G4double, G4double)
 {
+
   // The scattered gamma energy is sampled according to Klein - Nishina formula.
   // then accepted or rejected depending on the Scattering Function multiplied
@@ -174,17 +171,20 @@
   // (Nucl Phys 20(1960),15).
 
-  if (verboseLevel > 3)
-    G4cout << "Calling SampleSecondaries() of G4LivermoreComptonModel" << G4endl;
-
   G4double photonEnergy0 = aDynamicGamma->GetKineticEnergy();
-  
-  if (photonEnergy0 <= lowEnergyLimit)
-  {
+
+  if (verboseLevel > 3) {
+    G4cout << "G4LivermoreComptonModel::SampleSecondaries() E(MeV)= " 
+	   << photonEnergy0/MeV << " in " << couple->GetMaterial()->GetName() 
+	   << G4endl;
+  }
+  
+  // low-energy gamma is absorpted by this process
+  if (photonEnergy0 <= lowEnergyLimit) 
+    {
       fParticleChange->ProposeTrackStatus(fStopAndKill);
       fParticleChange->SetProposedKineticEnergy(0.);
       fParticleChange->ProposeLocalEnergyDeposit(photonEnergy0);
-      // SI - IS THE FOLLOWING RETURN NECESSARY ?
       return ;
-  }
+    }
 
   G4double e0m = photonEnergy0 / electron_mass_c2 ;
@@ -192,5 +192,8 @@
 
   // Select randomly one element in the current material
-  G4int Z = crossSectionHandler->SelectRandomAtom(couple,photonEnergy0);
+  //  G4int Z = crossSectionHandler->SelectRandomAtom(couple,photonEnergy0);
+  const G4ParticleDefinition* particle =  aDynamicGamma->GetDefinition();
+  const G4Element* elm = SelectRandomAtom(couple,particle,photonEnergy0);
+  G4int Z = (G4int)elm->GetZ();
 
   G4double epsilon0 = 1. / (1. + 2. * e0m);
@@ -212,5 +215,6 @@
       if ( alpha1/(alpha1+alpha2) > G4UniformRand())
       {
-        epsilon = std::exp(-alpha1 * G4UniformRand());  // std::pow(epsilon0,G4UniformRand())
+	// std::pow(epsilon0,G4UniformRand())
+        epsilon = std::exp(-alpha1 * G4UniformRand());  
         epsilonSq = epsilon * epsilon;
       }
@@ -238,6 +242,6 @@
   // Doppler broadening -  Method based on:
   // Y. Namito, S. Ban and H. Hirayama, 
-  // "Implementation of the Doppler Broadening of a Compton-Scattered Photon Into the EGS4 Code" 
-  // NIM A 349, pp. 489-494, 1994
+  // "Implementation of the Doppler Broadening of a Compton-Scattered Photon 
+  // into the EGS4 Code", NIM A 349, pp. 489-494, 1994
   
   // Maximum number of sampling iterations
@@ -257,5 +261,6 @@
       eMax = photonEnergy0 - bindingE;
      
-      // Randomly sample bound electron momentum (memento: the data set is in Atomic Units)
+      // Randomly sample bound electron momentum 
+      // (memento: the data set is in Atomic Units)
       G4double pSample = profileData.RandomSelectMomentum(Z,shell);
       // Rescale from atomic units
@@ -299,15 +304,22 @@
 
   if (photonEnergy1 > 0.)
-  {
-    fParticleChange->SetProposedKineticEnergy(photonEnergy1) ;
-  }
+    {
+      fParticleChange->SetProposedKineticEnergy(photonEnergy1) ;
+    }
   else
-  {
-    fParticleChange->SetProposedKineticEnergy(0.) ;
-    fParticleChange->ProposeTrackStatus(fStopAndKill);
-  }
+    {
+      photonEnergy1 = 0.;
+      fParticleChange->SetProposedKineticEnergy(0.) ;
+      fParticleChange->ProposeTrackStatus(fStopAndKill);   
+    }
 
   // Kinematics of the scattered electron
   G4double eKineticEnergy = photonEnergy0 - photonEnergy1 - bindingE;
+
+  // protection against negative final energy: no e- is created
+  if(eKineticEnergy < 0.0) {
+    fParticleChange->ProposeLocalEnergyDeposit(photonEnergy0 - photonEnergy1);
+    return;
+  }
   G4double eTotalEnergy = eKineticEnergy + electron_mass_c2;
 
@@ -329,28 +341,11 @@
   eDirection.rotateUz(photonDirection0);
 
-// SI - The range test has been removed wrt original G4LowEnergyCompton class
+  // SI - The range test has been removed wrt original G4LowEnergyCompton class
 
   fParticleChange->ProposeLocalEnergyDeposit(bindingE);
   
-  G4DynamicParticle* dp = new G4DynamicParticle (G4Electron::Electron(),eDirection,eKineticEnergy) ;
+  G4DynamicParticle* dp = new G4DynamicParticle (G4Electron::Electron(),
+						 eDirection,eKineticEnergy) ;
   fvect->push_back(dp);
 }
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-G4double G4LivermoreComptonModel::GetMeanFreePath(const G4Track& track,
-					     G4double, // previousStepSize
-					     G4ForceCondition*)
-{
-  const G4DynamicParticle* photon = track.GetDynamicParticle();
-  G4double energy = photon->GetKineticEnergy();
-  const G4MaterialCutsCouple* couple = track.GetMaterialCutsCouple();
-  size_t materialIndex = couple->GetIndex();
-
-  G4double meanFreePath;
-  if (energy > highEnergyLimit) meanFreePath = meanFreePathTable->FindValue(highEnergyLimit,materialIndex);
-  else if (energy < lowEnergyLimit) meanFreePath = DBL_MAX;
-  else meanFreePath = meanFreePathTable->FindValue(energy,materialIndex);
-  return meanFreePath;
-}
-
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4LivermoreGammaConversionModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4LivermoreGammaConversionModel.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4LivermoreGammaConversionModel.cc	(revision 1055)
@@ -24,7 +24,19 @@
 // ********************************************************************
 //
-// $Id: G4LivermoreGammaConversionModel.cc,v 1.1 2008/10/30 14:16:35 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-02 $
-//
+// $Id: G4LivermoreGammaConversionModel.cc,v 1.6 2009/05/02 09:14:43 sincerti Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+//
+//
+// Author: Sebastien Inserti
+//         30 October 2008
+//
+// History:
+// --------
+// 12 Apr 2009   V Ivanchenko Cleanup initialisation and generation of secondaries:
+//                  - apply internal high-energy limit only in constructor 
+//                  - do not apply low-energy limit (default is 0)
+//                  - use CLHEP electron mass for low-enegry limit
+//                  - remove MeanFreePath method and table
+
 
 #include "G4LivermoreGammaConversionModel.hh"
@@ -37,16 +49,12 @@
 
 G4LivermoreGammaConversionModel::G4LivermoreGammaConversionModel(const G4ParticleDefinition*,
-                                             const G4String& nam)
-:G4VEmModel(nam),smallEnergy(2.*MeV),isInitialised(false)
-{
-  lowEnergyLimit = 1.022000 * MeV;
+								 const G4String& nam)
+  :G4VEmModel(nam),smallEnergy(2.*MeV),isInitialised(false),
+   crossSectionHandler(0),meanFreePathTable(0)
+{
+  lowEnergyLimit = 2.0*electron_mass_c2;
   highEnergyLimit = 100 * GeV;
-  
-  G4cout << "Livermore Gamma conversion is constructed " << G4endl
-         << "Energy range: "
-         << lowEnergyLimit / keV << " keV - "
-         << highEnergyLimit / GeV << " GeV"
-         << G4endl;
-	 
+  SetHighEnergyLimit(highEnergyLimit);
+  	 
   verboseLevel= 0;
   // Verbosity scale:
@@ -57,4 +65,11 @@
   // 4 = entering in methods
 
+  if(verboseLevel > 0) {
+    G4cout << "Livermore Gamma conversion is constructed " << G4endl
+	   << "Energy range: "
+	   << lowEnergyLimit / MeV << " MeV - "
+	   << highEnergyLimit / GeV << " GeV"
+	   << G4endl;
+  }
 }
 
@@ -63,44 +78,29 @@
 G4LivermoreGammaConversionModel::~G4LivermoreGammaConversionModel()
 {  
-  delete meanFreePathTable;
-  delete crossSectionHandler;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-void G4LivermoreGammaConversionModel::Initialise(const G4ParticleDefinition* particle,
-                                       const G4DataVector& cuts)
+  if (crossSectionHandler) delete crossSectionHandler;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+void 
+G4LivermoreGammaConversionModel::Initialise(const G4ParticleDefinition*,
+					    const G4DataVector&)
 {
   if (verboseLevel > 3)
     G4cout << "Calling G4LivermoreGammaConversionModel::Initialise()" << G4endl;
 
-  InitialiseElementSelectors(particle,cuts);
-
-  // Energy limits
-  
-  if (LowEnergyLimit() < lowEnergyLimit)
+  if (crossSectionHandler)
   {
-    G4cout << "G4LivermoreGammaConversionModel: low energy limit increased from " << 
-	LowEnergyLimit()/eV << " eV to " << lowEnergyLimit << " eV" << G4endl;
-    SetLowEnergyLimit(lowEnergyLimit);
+    crossSectionHandler->Clear();
+    delete crossSectionHandler;
   }
 
-  if (HighEnergyLimit() > highEnergyLimit)
-  {
-    G4cout << "G4LivermoreGammaConversionModel: high energy limit decreased from " << 
-	HighEnergyLimit()/GeV << " GeV to " << highEnergyLimit << " GeV" << G4endl;
-    SetHighEnergyLimit(highEnergyLimit);
-  }
-
   // Read data tables for all materials
   
   crossSectionHandler = new G4CrossSectionHandler();
-  crossSectionHandler->Initialise(0,1.0220*MeV,100.*GeV,400);
+  crossSectionHandler->Initialise(0,lowEnergyLimit,100.*GeV,400);
   G4String crossSectionFile = "pair/pp-cs-";
   crossSectionHandler->LoadData(crossSectionFile);
 
-  meanFreePathTable = 0;
-  meanFreePathTable = crossSectionHandler->BuildMeanFreePathForMaterials();
-
   //
   
@@ -108,28 +108,30 @@
     G4cout << "Loaded cross section files for PenelopeGammaConversion" << G4endl;
 
-  G4cout << "Livermore Gamma Conversion model is initialized " << G4endl
-         << "Energy range: "
-         << LowEnergyLimit() / MeV << " MeV - "
-         << HighEnergyLimit() / GeV << " GeV"
-         << G4endl;
+  if (verboseLevel > 0) { 
+    G4cout << "Livermore Gamma Conversion model is initialized " << G4endl
+	   << "Energy range: "
+	   << LowEnergyLimit() / MeV << " MeV - "
+	   << HighEnergyLimit() / GeV << " GeV"
+	   << G4endl;
+  }
 
   if(isInitialised) return;
-
-  if(pParticleChange)
-    fParticleChange = reinterpret_cast<G4ParticleChangeForGamma*>(pParticleChange);
-  else
-    fParticleChange = new G4ParticleChangeForGamma();
-  isInitialised = true;}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-G4double G4LivermoreGammaConversionModel::ComputeCrossSectionPerAtom(
-                                       const G4ParticleDefinition*,
-                                             G4double GammaEnergy,
-                                             G4double Z, G4double,
-                                             G4double, G4double)
-{
-  if (verboseLevel > 3)
-    G4cout << "Calling ComputeCrossSectionPerAtom() of G4LivermoreGammaConversionModel" << G4endl;
+  fParticleChange = GetParticleChangeForGamma();
+  isInitialised = true;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+G4double 
+G4LivermoreGammaConversionModel::ComputeCrossSectionPerAtom(const G4ParticleDefinition*,
+							    G4double GammaEnergy,
+							    G4double Z, G4double,
+							    G4double, G4double)
+{
+  if (verboseLevel > 3) {
+    G4cout << "Calling ComputeCrossSectionPerAtom() of G4LivermoreGammaConversionModel" 
+	   << G4endl;
+  }
+  if (GammaEnergy < lowEnergyLimit || GammaEnergy > highEnergyLimit) return 0;
 
   G4double cs = crossSectionHandler->FindValue(G4int(Z), GammaEnergy);
@@ -173,14 +175,20 @@
     {
       // Select randomly one element in the current material
-      const G4Element* element = crossSectionHandler->SelectRandomElement(couple,photonEnergy);
+      //const G4Element* element = crossSectionHandler->SelectRandomElement(couple,photonEnergy);
+      const G4ParticleDefinition* particle =  aDynamicGamma->GetDefinition();
+      const G4Element* element = SelectRandomAtom(couple,particle,photonEnergy);
 
       if (element == 0)
 	{
-	  G4cout << "G4LivermoreGammaConversionModel::SampleSecondaries - element = 0" << G4endl;
+	  G4cout << "G4LivermoreGammaConversionModel::SampleSecondaries - element = 0" 
+		 << G4endl;
+	  return;
 	}
       G4IonisParamElm* ionisation = element->GetIonisation();
-       if (ionisation == 0)
+      if (ionisation == 0)
 	{
-	  G4cout << "G4LivermoreGammaConversionModel::SampleSecondaries - ionisation = 0" << G4endl;
+	  G4cout << "G4LivermoreGammaConversionModel::SampleSecondaries - ionisation = 0" 
+		 << G4endl;
+	  return;
 	}
 
@@ -272,8 +280,7 @@
   // distribution with respect to the Z axis along the parent photon
   
-//  aParticleChange.SetNumberOfSecondaries(2) ; 
   G4double electronKineEnergy = std::max(0.,electronTotEnergy - electron_mass_c2) ;
   
-// SI - The range test has been removed wrt original G4LowEnergyGammaconversion class
+  // SI - The range test has been removed wrt original G4LowEnergyGammaconversion class
 
   G4ThreeVector electronDirection (dxEle, dyEle, dzEle);
@@ -287,5 +294,5 @@
   G4double positronKineEnergy = std::max(0.,positronTotEnergy - electron_mass_c2) ;
 
-// SI - The range test has been removed wrt original G4LowEnergyGammaconversion class
+  // SI - The range test has been removed wrt original G4LowEnergyGammaconversion class
 
   G4ThreeVector positronDirection (dxPos, dyPos, dzPos);
@@ -337,20 +344,2 @@
 } 
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-G4double G4LivermoreGammaConversionModel::GetMeanFreePath(const G4Track& track, 
-						     G4double, // previousStepSize
-						     G4ForceCondition*)
-{
-  const G4DynamicParticle* photon = track.GetDynamicParticle();
-  G4double energy = photon->GetKineticEnergy();
-  const G4MaterialCutsCouple* couple = track.GetMaterialCutsCouple();
-  size_t materialIndex = couple->GetIndex();
-
-  G4double meanFreePath;
-  if (energy > highEnergyLimit) meanFreePath = meanFreePathTable->FindValue(highEnergyLimit,materialIndex);
-  else if (energy < lowEnergyLimit) meanFreePath = DBL_MAX;
-  else meanFreePath = meanFreePathTable->FindValue(energy,materialIndex);
-  return meanFreePath;
-}
-
